// ----------------------------------------------------------------------- //
// _main.cpp	main file
//
// last edited:	2001-05-12 by Bjrn Paetzel
// 
// Copyright (C) 2001 by Bjrn Paetzel <kolrabi@gmx.de>
// ----------------------------------------------------------------------- //

// ----------------------------------------------------------------------- //
// includes 

#include "stdafx.h"
#include "mmsystem.h"

#include "dsound.h"
#include "_window.h"
#include "_gfx.h"
#include "_render.h"
#include "_shared.h"
#include "_sound.h"
#include "_input.h"

// ----------------------------------------------------------------------- //


// ----------------------------------------------------------------------- //
// variables

bool fs = true;

int  wndWidth  = 640;
int  wndHeight = 480;

// ----------------------------------------------------------------------- //


// ----------------------------------------------------------------------- //
// functions



// processes the command line switches

void ProcessCmdLine
	(
		char *cmd					// command line
	)
{
	char	*p;

	strlwr(cmd);

	if (p = strstr(cmd, "-w"))
		fs = false;

	if (p = strstr(cmd, "-x"))
	{
		wndWidth = atoi(p+2);
		if (wndWidth<320)
			wndWidth = 320;
	}

	if (p = strstr(cmd, "-y"))
	{
		wndHeight = atoi(p+2);
		if (wndHeight<200)
			wndHeight = 200;
	}
}



// main routine
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	ProcessCmdLine(lpCmdLine);

	_log_init();

	_file_loadpak("data.pak");

	srand(GetTickCount());

	if (!_win_init(wndWidth, wndHeight, hInstance, fs ))
		return 1;

	ShowWindow(hWnd, SW_SHOW);

	if (!_gfx_init( wndWidth, wndHeight, fs ))
		return 1;

	if (!_r_init())
		return 1;

	_input_init( hInstance, hWnd );

	_sound_init( hWnd );
	_world_init();

	_win_mainloop();

	_world_deinit();
	_sound_deinit();
	_r_deinit();
	_gfx_deinit();

	_log_deinit();

	return 0;
}

// ----------------------------------------------------------------------- //
